#include "main.h"
#include "draw.h"
#include "input.h"
#include "player.h"

static int running = 1;
static void init(void);
static void update(void);
static void draw(void);

int
main(void)
{
	init();

	while (running) {
		update();
		draw();

		if (input_pressed(K_EXIT)) {
			running = 0;
		}
	}
	return 1;
}

static void
init(void)
{
	input_init();
}

static void
update(void)
{
	input_step();
	player_update();
}

static void
draw(void)
{
	dclear(C_WHITE);
	player_draw();
	dupdate();
}
